

typedef void (*tar_threadstart)(void);

typedef void (*tar_threadcreator)(tar_threadstart);



static void print_error(FILE *where,char *fmt, ...) {
  char temp[10000];
  va_list ap;
  va_start(ap, fmt);{
    vsnprintf (temp, 9998, fmt, ap);
  }va_end(ap);
  //syslog(LOG_INFO,temp);
  fprintf(where,"librollendurchmesserzeistsammler / threads.c: %s\n",temp);
}

static int set_pid_priority(pid_t pid,int policy,int priority,char *message,char *name){
  struct sched_param par={0};
  par.sched_priority=priority;
  if((sched_setscheduler(pid,policy,&par)!=0)){
    print_error(stderr,message,policy==SCHED_FIFO?"SCHED_FIFO":policy==SCHED_RR?"SCHED_RR":policy==SCHED_OTHER?"SCHED_OTHER":"SCHED_UNKNOWN",priority,pid,name,strerror(errno));
    return 0;
  }
  return 1;
}

static void set_realtime(int type, int priority){
  set_pid_priority(0,type,priority,"Unable to set %s/%d for %d (\"%s\"). (%s)", "a gc thread");
}

///////////////

static void set_free_thread_prio(void){
  set_realtime(SCHED_FIFO,
               audio_priority >= 2
               ? GC_MAX(sched_get_priority_min(SCHED_FIFO),audio_priority-1)
               : audio_priority);
}

static void* thread_start_free(void *arg){
  tar_threadstart threadstart=(tar_threadstart)arg;
  threadstart();
  return NULL;
}

static void free_creator(tar_threadstart threadstart){
  pthread_t *thread;
  thread=calloc(sizeof(pthread_t*),1);
  pthread_create(thread,NULL,thread_start_free,threadstart);
}

///////////////

static void set_snapshot_thread_prio(void){
  set_realtime(SCHED_FIFO,audio_priority);
}

static void* thread_start_snapshot(void *arg){
  tar_threadstart threadstart=(tar_threadstart)arg;
  threadstart();
  return NULL;
}

static void snapshot_creator(tar_threadstart threadstart){
  pthread_t *thread;
  thread=calloc(sizeof(pthread_t*),1);
  pthread_create(thread,NULL,thread_start_snapshot,threadstart);


}

///////////////

static void set_mark_thread_prio(void){
  set_realtime(SCHED_RR,sched_get_priority_min(SCHED_RR));
}

static void* thread_start_mark(void *arg){
  tar_threadstart threadstart=(tar_threadstart)arg;
  threadstart();
  return NULL;
}

static void mark_creator(tar_threadstart threadstart){
  pthread_t *thread;
  thread=calloc(sizeof(pthread_t*),1);
  pthread_create(thread,NULL,thread_start_mark,threadstart);
}
